import { Component, OnDestroy, OnInit } from '@angular/core';

//import { ToogleService } from '@xdf/layouts';
import { Chart } from 'angular-highcharts';
import * as Highcharts from 'highcharts';
import { Subscription } from 'rxjs';

@Component({
  selector: 'byte-heat-map',
  templateUrl: './heat-map.component.html',
  styleUrls: ['./heat-map.component.scss']
})
export class HeatMapComponent implements OnInit, OnDestroy {

  subscriptionToogle: Subscription;

  constructor(
    //protected toogleService: ToogleService
    ) {

  }
  ngOnDestroy(): void {
    if (this.subscriptionToogle) {
      this.subscriptionToogle.unsubscribe();
    }
  }

  chart: Chart;
  //   chart = new Chart({
  //     chart: {
  //         type: 'spline',
  //         marginRight: 10,
  //         events: {
  //             load: function () {

  //                 // set up the updating of the chart each second
  //                 const series = this.series[0];
  //                 setInterval(function () {
  //                     const x = (new Date()).getTime(), // current time
  //                         y = Math.random();
  //                     series.addPoint([x, y], true, true);
  //                 }, 1000);
  //             }
  //         }
  //     },
  //     title: {
  //         text: 'Live random data'
  //     },
  //     xAxis: {
  //         type: 'datetime',
  //         tickPixelInterval: 150
  //     },
  //     yAxis: {
  //         title: {
  //             text: 'Value'
  //         },
  //         plotLines: [{
  //             value: 0,
  //             width: 1,
  //             color: '#808080'
  //         }]
  //     },
  //     tooltip: {
  //         formatter: function () {
  //             return '<b>' + this.series.name + '</b><br/>' +
  //                 Highcharts.dateFormat('%Y-%m-%d %H:%M:%S', this.x) + '<br/>' +
  //                 Highcharts.numberFormat(this.y, 2);
  //         }
  //     },
  //     legend: {
  //         enabled: false
  //     },
  //     exporting: {
  //         enabled: false
  //     },
  //     series: [{
  //         name: 'Random data',
  //         data: (function () {
  //             // generate an array of random data
  //             const data = [],
  //                 time = (new Date()).getTime();
  //             let i: any;

  //             for (i = -19; i <= 0; i += 1) {
  //                 data.push({
  //                     x: time + i * 1000,
  //                     y: Math.random()
  //                 });
  //             }
  //             return data;
  //         }())
  //     }] as Array<any>
  // });

  ngOnInit() {
    this.chart = new Chart({
      chart: {
        type: 'heatmap',
        events: {
          load: function(event:any) {
            event.target.reflow();
          }
        }
      },

      boost: {
        useGPUTranslations: true
      },
      credits: {
        enabled: false
      },
      title: {
        text: 'Cantidad de mensajes por horario de actividad del cliente',
        align: 'center',
        x: 40
      },

      xAxis: {
        type: 'datetime',
        min: Date.UTC(2020, 0, 1),
        max: Date.UTC(2020, 0, 10, 59, 59, 59),
        labels: {
          align: 'left',
          x: 5,
          y: 14,
          format: '{value:%d/%m %H:%M}' // long month
        },
        showLastLabel: false,
        tickLength: 10,
        tickWidth: 1
      },

      yAxis: {
        title: {
          text: null
        },
        labels: {
          formatter: function () {
            return 'H' + (this.value + 1) + ': ' + (3*this.value < 10 ? '0' : '') + 3*this.value + ':00' + ' - ' + ((this.value + 3) < 10 ? '0' : '') + (this.value + 3) + ':00';
          },
          format: 'H{value:}:{3*value}:00 - {value + 3}:00'
        },
        minPadding: 0,
        maxPadding: 0,
        startOnTick: false,
        endOnTick: false,
        tickPositions: [0, 1, 2, 3, 4, 5, 6, 7],
        tickWidth: 1,
        min: 0,
        max: 7,
        reversed: true
      },

      colorAxis: {
        stops: [
          [0, '#1c84c6'],
          [0.5, '#23c6c8'],
          [1, '#E1F5B1']
        ],
        min: -15,
        max: 25,
        startOnTick: false,
        endOnTick: false,
        labels: {
          format: '{value}'
        }
      },

      series: [{
        boostThreshold: 100,
        borderWidth: 0,
        nullColor: '#DDD',
        borderColor: '#ddd',
        colsize: 24 * 36e5, // one day
        tooltip: {
          headerFormat: '{point.x:%e %b}',
          pointFormat: '{point.x:%e %b, %Y} {point.y}:00: <b>{point.value} ℃</b>'
        },
        turboThreshold: Number.MAX_VALUE, // #3404, remove after 4.0.5 release
        data: [
          [1577854800000, 0, 2.7],
          [1577854800000, 1, 2.5],
          [1577854800000, 2, 3.5],
          [1577854800000, 3, 4.5],
          [1577854800000, 4, 5.5],
          [1577854800000, 5, 2.5],
          [1577854800000, 6, 2.5],
          [1577854800000, 7, 2.5],
          [1577854800000, 8, 2.5],
          [1577854800000, 9, 2.5],
          [1577854800000, 10, 2.5],
          [1577854800000, 11, 2.5],
          [1577854800000, 12, 2.5],
          [1577854800000, 13, 2.5],
          [1577854800000, 14, 2.5],
          [1577854800000, 15, 2.5],
          [1577854800000, 16, 2.5],
          [1577854800000, 17, 2.5],
          [1577854800000, 18, 2.5],
          [1577854800000, 19, 2.5],
          [1577854800000, 20, 2.5],
          [1577854800000, 21, 2.5],
          [1577854800000, 22, 2.5],
          [1577854800000, 23, 2.5], //1577941200000

          [1577941200000, 0, 9],
          [1577941200000, 1, 11],
          [1577941200000, 2, 12],
          [1577941200000, 3, 11],
          [1577941200000, 4, 15],
          [1577941200000, 5, 16],
          [1577941200000, 6, 17],
          [1577941200000, 7, 18],
          [1577941200000, 8, 19],
          [1577941200000, 9, 11],
          [1577941200000, 10, 12],
          [1577941200000, 11, 13],
          [1577941200000, 12, 14],
          [1577941200000, 13, 12],
          [1577941200000, 14, 15],
          [1577941200000, 15, 19],
          [1577941200000, 16, 20],
          [1577941200000, 17, 16],
          [1577941200000, 18, 18],
          [1577941200000, 19, 15],
          [1577941200000, 20, 15],
          [1577941200000, 21, 15],
          [1577941200000, 22, 15],
          [1577941200000, 23, 15],
          [1578027600000, 0, 13],

          [1578027600000, 1, 12],
          [1578027600000, 2, 3],
          [1578027600000, 3, 12],
          [1578027600000, 4, 4],
          [1578027600000, 5, 8],
          [1578027600000, 6, 15],
          [1578027600000, 7, 12],
          [1578027600000, 8, 19],
          [1578027600000, 9, 2],
          [1578027600000, 10, 16],
          [1578027600000, 11, 16],
          [1578027600000, 12, 19],
          [1578027600000, 13, 9],
          [1578027600000, 14, 7],
          [1578027600000, 15, 19],
          [1578027600000, 16, 9],
          [1578027600000, 17, 13],
          [1578027600000, 18, 17],
          [1578027600000, 19, 13],
          [1578027600000, 20, 16],
          [1578027600000, 21, 10],
          [1578027600000, 22, 10],
          [1578027600000, 23, 19],

          [1578114000000, 0, 17], [1578114000000, 1, 6], [1578114000000, 2, 13], [1578114000000, 3, 4], [1578114000000, 4, 7], [1578114000000, 5, 4], [1578114000000, 6, 9], [1578114000000, 7, 9], [1578114000000, 8, 3], [1578114000000, 9, 9], [1578114000000, 10, 11], [1578114000000, 11, 7], [1578114000000, 12, 14], [1578114000000, 13, 15], [1578114000000, 14, 8], [1578114000000, 15, 11], [1578114000000, 16, 14], [1578114000000, 17, 19], [1578114000000, 18, 3], [1578114000000, 19, 20], [1578114000000, 20, 6], [1578114000000, 21, 13], [1578114000000, 22, 10], [1578114000000, 23, 18], [1578114000000, 24, 16]
        ]
      }] as Array<any>

    });

    // this.subscriptionToogle = this.toogleService.changeEmitted$.subscribe(change => {
    //   setTimeout(() => {
    //     Highcharts.charts.forEach(chart => chart.reflow());;
    //     console.log("test");
    //   }, 500);
    // });
  }

}
